namespace clippy::targets {
class Target {
 public:
  virtual void Execute() = 0;
};

class EmptyTarget : public Target {
 public:
  void Execute() override {}
};

class OpenProjectConfig : public Target {
 public:
  OpenProjectConfig(Config config) : config_(config) {}

  void Execute() override { config_.Edit(); }

 private:
  Config config_;
};

class CreateProjectConfig : public Target {
 public:
  CreateProjectConfig(ProjectList& projects) : projects_(projects) {}

  void Execute() override {
    auto scripts_path = utils::GetProjectDirectory() / "scripts";
    std::filesystem::create_directories(scripts_path);

    auto config = projects_.GetNewConfig(scripts_path);
    config.Edit();
  }

 private:
  ProjectList& projects_;
};
}  // namespace clippy::targets
